;mIRCamp (c) 2000 DragonZap (dragonzap1@aol.com)
;WinAmp is (tm) Nullsoft, www.winamp.com

dialog mircamp {
  size -1 -1 500 300
  title "mIRCamp"

  tab "Play control",1,5 5 490 265
  ;Playlist
  list 2,15 35 200 220,size tab 1
  ;Control buttons
  box "Play control",3,260 33 220 47,tab 1
  button "| &< Prev",4,270 50 50 20,tab 1
  button "&Play",5,320 50 50 20,tab 1
  button "&Stop",6,370 50 50 20,tab 1
  button "Next &> |",7,420 50 50 20,tab 1

  ;File buttons
  box "Files",10,260 85 220 87,tab 1
  button "+ Fi&le",11,270 100 50 20,tab 1
  button "+ Di&rectory",12,320 100 100 20,tab 1
  button "+ &URL",13,420 100 50 20,tab 1
  button "- &Delete entry",14,270 120 100 20,tab 1
  button "- Clear playlist",15,370 120 100 20,tab 1
  button "&Save M3U",16,270 140 100 20,tab 1
  button "L&oad M3U",17,370 140 100 20,tab 1

  ;Shuffle/looping controls
  box "Shuffling and Looping",18,260 180 220 67,tab 1
  check "Loop playback at playlist end",19,270 195 200 20,tab 1
  check "Shuffle at end",20,270 215 100 20,tab 1
  button "S&huffle now",21,370 215 100 20,tab 1

  ;Playlist stuff buttons

  button "?",25,220 100 20 20,tab 1
  button "A",26,220 160 20 20,tab 1

  tab "Plugins",51
  ;Plugin directories/files
  list 52,15 35 200 200,size tab 51
  box "Input plugin directory",53,220 33 260 47,tab 51
  edit "",54,230 50 220 20,tab 51 read autohs
  button "...",55,450 50 19 19,tab 51
  button "&About",56,20 240 75 20,tab 51
  button "&Configure",57,135 240 75 20,tab 51

  box "Output plugin",58,220 83 260 67,tab 51
  text "",59,230 100 240 20,tab 51
  edit "",60,230 120 180 20,tab 51 read autohs
  button "A",61,410 120 19 19,tab 51
  button "C",62,430 120 19 19,tab 51
  button "...",63,450 120 19 19,tab 51

  box "DSP plugin",64,220 153 260 67,tab 51
  button "x",65,230 170 12 12,tab 51
  text "",66,243 170 227 20,tab 51
  edit "",67,230 190 200 20,tab 51 read autohs
  button "C",68,430 190 19 19,tab 51
  button "...",69,450 190 19 19,tab 51

  tab "Other options",101
  box "Auto save",102,15 35 470 70,tab 101
  check "Auto save/load playlist to/from:",103,25 55 170 20,tab 101
  edit "",104,195 55 260 20,tab 101 read autohs disable
  button "...",105,455 55 20 20,tab 101 disable
  check "Start playback on mIRC start",106,25 75 170 20,tab 101 disable
  check "Double-click in playlist starts playback",107,25 110 200 20,tab 101

  text "If mIRCamp is eating your resources, you may close it completely by clicking on 'Unload DLL'. This will stop all playback and erase your playlist. The DLL will be reloaded if the mIRCamp dialog is opened again. You may also uninstall the entire script by clicking the 'Uninstall mIRCamp' button.",119,15 190 470 40,tab 101
  button "Unload DLL",120,15 240 70 20,tab 101
  button "Uninstall mIRCamp",121,90 240 100 20,tab 101

  edit "",499,5 275 450 20,read
  button "Close",500,460 275 35 20,cancel default
}

;DSP module selector table
dialog dspmod {
  title "DSP Module Selector"
  size -1 -1 200 200

  list 4,5 5 190 170
  button "&Ok",5,5 175 50 20,ok
  button "&Cancel",6,145 175 50 20,cancel
  edit "-1",500,0 0 0 0,hide autohs result
}
alias mircamp {
  if ($dialog(dz.mircamp) == $null) dialog -m dz.mircamp mircamp
  else dialog -v dz.mircamp
}
on *:LOAD:{
  linesep -s
  echo $colour(info2) -ts Type /mircamp to open up mIRCamp
  linesep -s
}
on *:START:{
  ;Unset all temporary variables
  unset %dz.mamp.*

  var %opts = $get-cfg(opts)
  if (( $get-cfg(listsave) != $null ) && ( $gettok(%opts,3,32) == 1 )) {
    linesep -s
    if ( $get-cfg(auto-fail) != $null ) {
      echo $colour(info2) -ts mIRCamp failed to load last time -- unsetting auto-play option
      linesep -s
      set-cfg auto-fail
      set-cfg opts $puttok(%opts,0,3,32)
      return
    }
    echo $colour(info2) -ts Loading mIRCamp...
    set-cfg auto-fail 1
    flushini $cfg-file
    init-mircamp
    start-playback
    set-cfg auto-fail
    flushini $cfg-file
    echo $colour(info2) -ts mIRCamp loaded successfully!
    linesep -s
  }
}

;Loads all the plugins and the playlist if one is saved
alias -l init-mircamp {
  var %opts = $get-cfg(opts)

  ;Set notify mode to MIDI
  winamp Misc notify midi

  winamp Queue looping $iif($gettok(%opts,1,32) == 1,on,off)
  winamp Queue shuffle $iif($gettok(%opts,2,32) == 1,auto-on,auto-off)

  if ( %dz.mamp.gp != $null ) return
  var %psave = $psave
  if ( %psave != $null ) {
    winamp Queue loadm3u %psave
    winamp Queue setcurrent $get-cfg(lastsong)
  }

  var %inp-dir = $get-cfg(inp-dir)
  var %outp = $get-cfg(outp)
  var %dspp = $get-cfg(dspp)
  var %dspm = $get-cfg(dspm)
  load-inputs %inp-dir
  load-output %outp
  if ( %dspm != $null ) load-dsp %dspm %dspp

  set %dz.mamp.gp 1
}

;To do when the dialog opens
on *:DIALOG:dz.mircamp:init:0:{
  ;Enables title/length-checking
  title-fix
  .timerdz.mamp.chktitle -mo 0 500 title-fix

  ;Set paused/unpaused/playing button
  var %stat = $winamp(CurrentMusic,status)
  if ( %stat == playing ) did -o dz.mircamp 5 1 &Pause
  else if ( %stat == paused ) did -o dz.mircamp 5 1 Un&pause

  ;Fill the playlist if any
  init-mircamp

  ;Blocks/unblocks "play"
  block-play

  refill-playlist
  did -o dz.mircamp 54 1 $get-cfg(inp-dir)

  var %psave = $psave
  var %opts = $get-cfg(opts)
  var %inp-dir = $get-cfg(inp-dir)
  var %outp = $get-cfg(outp)
  var %dspp = $get-cfg(dspp)
  var %dspm = $get-cfg(dspm)

  ;Check appropriate dialog boxes
  if ( %psave != $null ) {
    did -c dz.mircamp 103
    did -e dz.mircamp 104,105,106
    did -o dz.mircamp 104 1 %psave 
  }
  if ( %opts != $null ) {
    if ( $gettok(%opts,1,32) == 1 ) did -c dz.mircamp 19
    if ( $gettok(%opts,2,32) == 1 ) did -c dz.mircamp 20
    if ( $gettok(%opts,3,32) == 1 ) did -c dz.mircamp 106
    if ( $gettok(%opts,4,32) == 1 ) did -c dz.mircamp 107
  }

  ;First time loading this session? Load the plugins.
  if ( %dspm == $null ) unset %dspp
  if (( %inp-dir == $null ) || ( %outp == $null )) {
    .timer -mo 1 1 did -f dz.mircamp 51
    return
  }
  did -o dz.mircamp 60 1 %outp
  did -o dz.mircamp 59 1 $winamp(PluginManager,description output)
  did -o dz.mircamp 66 1 $winamp(PluginManager,description dsp)
  did -o dz.mircamp 67 1 %dspp

  input-list
}

;And when it closes
on 1:DIALOG:dz.mircamp:sclick:500:{
  .timerdz.mamp.chktitle off
  set-cfg opts $did(19).state $did(20).state $did(106).state $did(107).state
  auto-save
  flushini $cfg-file
}

;No plugins? Block everything.
on *:DIALOG:dz.mircamp:sclick:1:block-play
alias -l block-play {
  if (( $winamp(PluginManager,inputcount) == 0 ) || ( $winamp(PluginManager,description output) == $null )) did -b dz.mircamp 4,5,6,7
  else {
    did -e dz.mircamp 4,5,6,7
    set %dz.mamp.gp 1
  }
}

;Auto-saves playlist
alias -l auto-save {
  if ( $dialog(dz.mircamp) == $null ) return
  if ( $did(dz.mircamp,103).state == 1 ) {
    winamp Queue savem3u $did(dz.mircamp,104)
    set-cfg lastsong $winamp(Queue,getcurrent)
  }
}

;Continuously checks the song title
alias -l title-fix {
  ;MIDIs interfere with the internal notify
  splay -m stop
  if ( $dialog(dz.mircamp) == $null ) {
    .timerdz.mamp.chktitle off
    return
  }
  if ( $winamp(CurrentMusic,status) == stopped ) {
    did -o dz.mircamp 499 1
    return
  }
  var %ctitle = $winamp(CurrentMusic,title)
  var %clen = $winamp(CurrentMusic,length)
  var %cpos = $winamp(CurrentMusic,position)
  var %cqueue = $winamp(Queue,getcurrent) $+ .
  if ( %cqueue != -1. ) move-ptr
  else unset %cqueue
  did -o dz.mircamp 499 1 $iif($winamp(CurrentMusic,status) == paused,(paused)) ( $+ $mtime(%cpos) $+ / $+ $mtime(%clen) $+ ) %cqueue %ctitle
}

;Why "on MIDIEND"? Because notify mode was set to "midi"
alias -l move-ptr {
  var %newsong = $winamp(Queue,getcurrent)
  if ( $dialog(dz.mircamp) != $null ) {
    if (( %dz.mamp.lastsong != -1 ) && ( %dz.mamp.lastsong != $null ) && ( %dz.mamp.lastsong != %newsong )) did -o dz.mircamp 2 %dz.mamp.lastsong %dz.mamp.lastsong $+ . $winamp(Queue,title [ %dz.mamp.lastsong ] ) ( $+ $mtime($winamp(Queue,length [ %dz.mamp.lastsong ] )) $+ )
    var %newtxt = --> %newsong $+ . $winamp(Queue,title [ %newsong ] ) ( $+ $mtime($winamp(Queue,length [ %newsong ] )) $+ )
    if (( %newsong > 0 ) && ( $did(dz.mircamp,2,%newsong) != %newtxt )) did -o dz.mircamp 2 %newsong %newtxt
  }
  if ( %newsong > 0 ) {
    set %dz.mamp.lastsong %newsong
    set-cfg lastsong %newsong
  }
  else unset %dz.mamp.lastsong
}
on *:MIDIEND:{
  var %cur = $winamp(Queue,getcurrent)
  set-cfg lastsong %cur
  if (( $dialog(dz.mircamp) != $null ) && (%cur < 2)) {
    if ( $winamp(CurrentMusic,status) == stopped ) did -o dz.mircamp 5 1 &Play
    ;Since shuffles and the like can happen at the end, may as well reload
    refill-playlist
    return
  }
  move-ptr
}

;Playlist double-click
on *:DIALOG:dz.mircamp:dclick:2:{
  var %sel = $did(2).sel
  if ( $mouse.key & 2 ) {
    ;Show file info instead
    winamp Info info $winamp(Queue,filename [ %sel ] )
    return
  }
  winamp Queue setcurrent %sel
  move-ptr
  did -c dz.mircamp 2 %sel
  if ( $did(107).state == 1 ) {
    if ( $start-playback == $null ) return
    did -o dz.mircamp 5 1 Pa&use
  }
}
alias -l start-playback {
  if (( $winamp(PluginManager,inputcount) == 0 ) || ( $winamp(PluginManager,description output) == $null )) return
  return $winamp(Play,<QUEUE>)
}

;Add a file
on *:DIALOG:dz.mircamp:sclick:11:.timer -mo 1 1 queue-file
alias -l queue-file {
  var %file = $openfile(Add file to playlist, [ [ $ldir ] $+ [ $gettypes ] ] )
  if ( %file == $null ) return
  if ( $winamp(Queue,add [ %file ] ) != $null ) did -a dz.mircamp 2 $calc($did(dz.mircamp,2).lines +1) $+ . $winamp(Queue,title last) ( $+ $mtime($winamp(Queue,length last)) $+ )
  set-ldir %file
}

;Add a directory
on *:DIALOG:dz.mircamp:sclick:12:.timer -mo 1 1 queue-dir
alias -l add-file {
  var %ok = $winamp(Queue,add [ $1- ] )
  if (( %ok == $null ) || ( $dialog(dz.mircamp) == $null )) return
  var %lpos = $calc($did(dz.mircamp,2).lines +1)
  did -a dz.mircamp 2 %lpos $+ . $winamp(Queue,title [ %lpos ] ) ( $+ $mtime($winamp(Queue,length [ %lpos ] )) $+ )
}
alias -l queue-dir {
  var %types = $gettypes
  var %dir = $sdir="Add directory to playlist" $ldir
  if (%dir == $null ) return
  ;Loop through all the file types
  var %ft = 1
  var %fc = $numtok(%types,59)

  ;The user probably likes it better if they can see the filenames as they load, so we'll put that in add-file
  while ( %ft <= %fc ) {
    ign $findfile(%dir,$gettok(%types,%ft,59),0,0,add-file $1-)
    inc %ft
  }
  set-ldir %dir
  auto-save
}

;Add a URL
on *:DIALOG:dz.mircamp:sclick:13:.timer -mo 1 1 queue-url
alias -l queue-url {
  var %add = $?="Add URL to playlist"
  if ( %add == $null ) return
  if ( $winamp(Queue,add [ %add ] ) != $null ) did -a dz.mircamp 2 $calc($did(dz.mircamp,2).lines +1) $+ . $winamp(Queue,title last) ( $+ $mtime($winamp(Queue,length last)) $+ )
}

;Delete a file from the playlist
on *:DIALOG:dz.mircamp:sclick:14:{
  var %del = $did(dz.mircamp,2).sel
  if (( %del < 1 ) || ( %del == $null )) return
  winamp Queue remove %del
  var %dc = %del
  var %max = $did(dz.mircamp,2).lines
  while ( %dc < %max ) {
    did -o dz.mircamp 2 %dc %dc $+ . $winamp(Queue,title [ %dc ] ) ( $+ $mtime( $winamp(Queue,length [ %dc ] ) ) $+ )
    inc %dc
  }
  ; Looks better if we save the delete until last
  did -d dz.mircamp 2 %max
  title-fix
  if ( $did(dz.mircamp,2).lines < %del ) did -c dz.mircamp 2 $did(dz.mircamp,2).lines
  else did -c dz.mircamp 2 %del
  update-playpause
}

;Clear the playlist
on *:DIALOG:dz.mircamp:sclick:15:.timer -mo 1 1 confirm-clear
alias -l confirm-clear {
  var %conf = $?!="Clear the playlist?"
  if ( %conf == $true ) {
    winamp Queue clear
    update-playpause
    refill-playlist
  }
}

;Save an M3U
on *:DIALOG:dz.mircamp:sclick:16:.timer -mo 1 1 save-m3u
alias -l save-m3u {
  var %sm3u = $savefile(Save M3U playlist, [ [ $ldir ] $+ *.m3u ] )
  if ( %sm3u == $null ) return
  winamp Queue savem3u %sm3u
  set-ldir %sm3u
}

;Load an M3U
on *:DIALOG:dz.mircamp:sclick:17:.timer -mo 1 1 load-m3u
alias -l load-m3u {
  var %wm3u = $openfile(Load an M3U playlist, [ [ $ldir ] $+ *.m3u ] )
  if ( %wm3u == $null ) return
  winamp Queue loadm3u %wm3u
    update-playpause
  refill-playlist
  set-ldir %wm3u
}

;Play/pause
on *:DIALOG:dz.mircamp:sclick:5:{
  var %stat = $winamp(CurrentMusic,status)
  if ( %stat == stopped ) {
    if ( $start-playback == $null ) return
    move-ptr
  }
  else if ( %stat == playing ) winamp CurrentMusic pause
  else if ( %stat == paused ) winamp CurrentMusic unpause
  update-playpause
  title-fix
}
alias -l update-playpause {
  if ( $dialog(dz.mircamp) == $null ) return
  var %stat = $winamp(CurrentMusic,status)
  if ( %stat == stopped ) did -o dz.mircamp 5 1 &Play
  else if ( %stat == playing ) did -o dz.mircamp 5 1 &Pause
  else if ( %stat == paused ) did -o dz.mircamp 5 1 Un&pause
}

;Stop
on *:DIALOG:dz.mircamp:sclick:6:{
  winamp Stop .
  update-playpause
}

;Previous song
on *:DIALOG:dz.mircamp:sclick:4:{
  var %cur = $winamp(Queue,getcurrent)
  if ( %cur == -1 ) return
  if (( $winamp(CurrentMusic,position) >= 3000 ) || ( %cur == 1 )) winamp Queue setcurrent current
  else winamp Queue setcurrent previous
}

;Next song
on *:DIALOG:dz.mircamp:sclick:7:{
  var %cur = $winamp(Queue,getcurrent)
  if ( %cur == -1 ) return
  winamp Queue setcurrent next
}

;Looping control
on *:DIALOG:dz.mircamp:sclick:19:winamp Queue looping $iif( $did(19).state == 1,on,off)

;Auto-shuffle control
on *:DIALOG:dz.mircamp:sclick:20:winamp Queue shuffle $iif( $did(20).state == 1,auto-on,auto-off)

;Shuffle now
on *:DIALOG:dz.mircamp:sclick:21:{
  winamp Queue shuffle now
  refill-playlist
}

;File info
on *:DIALOG:dz.mircamp:sclick:25:{
  var %sel = $did(dz.mircamp,2).sel
  if (( %sel < 1 ) || ( %sel == $null )) return
  winamp Info info $winamp(Queue,filename [ %sel ] )
}

;Select currently playing file
on *:DIALOG:dz.mircamp:sclick:26:{
  var %cur = $winamp(Queue,getcurrent)
  if ( %cur >= 1 ) did -c dz.mircamp 2 %cur
}

;Input about
on *:DIALOG:dz.mircamp:sclick:56:{
  var %sel = $did(52).sel
  if ( %sel == $null ) return
  winamp PluginManager about %sel
}

;Input config
on *:DIALOG:dz.mircamp:sclick:57:{
  var %sel = $did(52).sel
  if ( %sel == $null ) return
  winamp PluginManager config %sel
}

;Set input plugin directory
on *:DIALOG:dz.mircamp:sclick:55:.timer -mo 1 1 select-input
alias -l select-input {
  var %newdir = $sdir="Select WinAmp Input Plugins directory" "C:\Program Files\Winamp\Plugins\"
  if (%newdir == $null) return
  var %inputs = $load-inputs(%newdir)
  if ( %inputs == 0 ) {
    var %ans = $?!="No input plugins were found. Select this directory anyway?"
    if ( %ans == $false ) return
  }
  did -o dz.mircamp 54 1 %newdir
  set-cfg inp-dir %newdir
  input-list
}
;Lists input plugins
alias -l input-list {
  did -r dz.mircamp 52
  var %pmax = $winamp(PluginManager,inputcount)
  var %pcount = 1
  while (%pcount <= %pmax) {
    did -a dz.mircamp 52 $winamp(PluginManager,description [ %pcount ] )
    inc %pcount
  }
}
alias -l load-inputs {
  if ( $1 != $null ) return $findfile($1-,in_*.dll,0,1,input-load $1-)
  return 0
}
alias -l input-load winamp PluginManager load input $1-

;Output about
on *:DIALOG:dz.mircamp:sclick:61:winamp PluginManager about output
;Output config
on *:DIALOG:dz.mircamp:sclick:62:winamp PluginManager config output
;Output load
alias -l load-output {
  if ( $1 != $null ) {
    var %ret = $winamp(PluginManager,load output [ $1- ] )
    if ( $dialog(dz.mircamp) != $null ) {
      did -o dz.mircamp 60 1 $1-
      if ( %ret != $null ) did -o dz.mircamp 59 1 $winamp(PluginManager,description output)
    }
    return %ret
  }
}
on *:DIALOG:dz.mircamp:sclick:63:.timer -mo 1 1 select-output
alias -l select-output {
  var %outdir = $nofile($get-cfg(outp))
  if ( %outdir == $null ) set %outdir C:\Program Files\Winamp\Plugins\
  var %out = $openfile(Select output plugin, [ [ %outdir ] $+ out_*.dll ] )
  if ( %out == $null ) return
  if ($winamp(PluginManager,load output [ %out ] ) == $null) return
  set-cfg outp %out
  did -o dz.mircamp 60 1 %out
  did -o dz.mircamp 59 1 $winamp(PluginManager,description output)
}

;DSP remove
on *:DIALOG:dz.mircamp:sclick:65:.timer -mo 1 1 dsp-remove
alias -l dsp-remove {
  if ( $get-cfg(dspp) == $null ) return
  var %rm = $?!="Unload DSP plugin?"
  if ( %rm == $false ) return
  winamp PluginManager unload dsp
  did -o dz.mircamp 66,67 1
  set-cfg dspp
  set-cfg dspm
}
;DSP config
on *:DIALOG:dz.mircamp:sclick:68:winamp PluginManager config dsp
;DSP select
on *:DIALOG:dz.mircamp:sclick:69:.timer -mo 1 1 select-dsp
alias -l select-dsp {
  var %dspdir = $nofile(%olddsp)
  if ( %dspdir == $null ) set %dspdir C:\Program Files\Winamp\Plugins\
  var %dsp = $openfile(Select DSP plugin, [ [ %dspdir ] $+ dsp_*.dll ] )
  set %dz.mamp.dspsel %dsp

  ;Auto-select if there's only one DSP module
  var %dspmc = $winamp(PluginManager,uinfo dsp modcount [ %dsp ] )
  var %dspm
  if ( %dspmc <= 1 ) set %dspm 1
  else set %dspm $dialog(dz.dspmod,dspmod,-4)
  unset %dz.mamp.dspsel
  if (( %dsp == $null ) || ( %dspm == $null ) || ( %dspm == -1 )) return
  winamp PluginManager unload dsp
  if ($winamp(PluginManager,load dsp [ %dspm ] [ %dsp ] ) == $null) {
    if ( $dialog(dz.mircamp) != $null ) did -o dz.mircamp 66,67 1
    return
  }
  set-cfg dspp %dsp
  set-cfg dspm %dspm
  if ( $dialog(dz.mircamp) != $null ) {
    did -o dz.mircamp 67 1 %dsp
    did -o dz.mircamp 66 1 $winamp(PluginManager,description dsp)
  }
}
on *:DIALOG:dz.dspmod:init:0:{
  var %modcount = $winamp(PluginManager,uinfo dsp modcount [ %dz.mamp.dspsel ] )
  var %cm = 1
  while ( %cm <= %modcount ) {
    did -a dz.dspmod 4 $winamp(PluginManager,uinfo dsp modname [ %cm ] [ %dz.mamp.dspsel ] )
    inc %cm
  }
}
on *:DIALOG:dz.dspmod:sclick:4:did -o dz.dspmod 500 1 $did(dz.dspmod,4).sel
alias -l load-dsp {
  var %df = $2-
  var %dm = $1
  if ( $2 == $null ) return
  winamp PluginManager unload dsp
  if ($winamp(PluginManager,load dsp [ %dm ] [ %df ] ) == $null) {
    if ( $dialog(dz.mircamp) != $null ) did -o dz.mircamp 66,67 1
    return
  }
  if ( $dialog(dz.mircamp) != $null ) {
    did -o dz.mircamp 67 1 %df
    did -o dz.mircamp 66 1 $winamp(PluginManager,description dsp)
  }
}

;Select an auto-save file
on *:DIALOG:dz.mircamp:sclick:103,105:{
  if ( $did(103).state == 1 ) {
    did -e dz.mircamp 104,105,106
    if (( $did == 105 ) || ( $did(104) == $null )) .timer -mo 1 1 select-autosave $did
    else set-psave $did(104)
  }
  else {
    did -b dz.mircamp 104,105,106
    set-psave
  }
}
alias -l select-autosave {
  var %asave = $savefile(Auto-save playlist to M3U, [ [ $ldir ] $+ *.m3u ] )
  if ( %asave == $null ) {
    if (( $1 == 103 ) && ( $dialog(dz.mircamp) != $null )) {
      did -u dz.mircamp 103
      did -b dz.mircamp 104,105,106
    }
    return
  }
  set-psave %asave
  set-ldir %asave
  if ( $dialog(dz.mircamp) != $null ) did -o dz.mircamp 104 1 %asave
}

;Unloads the DLL/Uninstalls the script
on *:DIALOG:dz.mircamp:sclick:120,121:.timer -mo 1 1 unload-all $did
alias -l unload-all {
  var %sure
  if ( $1 == 120 ) set %sure $?!="Are you sure you want to unload the DLL? This will erase your playlist and unload all plugins."
  else if ( $1 == 121 ) set %sure $?!="Are you sure you want to uninstall mIRCamp?"
  if ( %sure == $false ) return
  if ( $dialog(dz.mircamp) != $null ) dialog -c dz.mircamp
  winamp FlushAllPlugins .
  unset %dz.mamp.*
  if ( $1 == 121 ) {
    linesep -s
    echo 12 -s $timestamp mIRCamp has been successfully uninstalled.
    linesep -s
    .unload -rs $script
  }
}

;Resets the playlist in the dialog
alias -l refill-playlist {
  unset %dz.mamp.lastsong
  if ( $dialog(dz.mircamp) == $null ) return
  var %oldsel = $did(dz.mircamp,2).sel
  var %listsize = $winamp(Queue,count)
  var %count = 1
  did -r dz.mircamp 2
  var %active = $winamp(Queue,getcurrent)
  set %dz.mamp.lastsong %active
  while (%count <= %listsize) {
    var %songlen = $winamp(Queue,length [ %count ] )
    if ( %count == %active) did -a dz.mircamp 2 --> %count $+ . $winamp(Queue,title [ %count ] ) ( $+ $mtime(%songlen) $+ )
    else did -a dz.mircamp 2 %count $+ . $winamp(Queue,title [ %count ] ) ( $+ $mtime(%songlen) $+ )
    inc %count
  }
  if (( %oldsel != $null ) && ( %oldsel >= 1 )) did -c dz.mircamp 2 %oldself
  auto-save
}

;Return $null on error, otherwise returns value after OK
alias winamp {
  var %ret = $dll($udll,$1,$2-)
  if ( $gettok(%ret,1,32) == OK ) return $gettok( %ret ,2-,32)
  return
}

;Takes a semicolon-delimited list and puts *. in front of each token
alias -l startype {
  var %tokc = $numtok($1-,59)
  var %ctok = 1
  var %newtok = $1-
  var %ntok
  while ( %ctok <= %tokc ) {
    set %ntok *. $+ $gettok(%newtok,%ctok,59)
    set %newtok $puttok(%newtok, %ntok,%ctok,59)
    inc %ctok
  }
  return %newtok
}

;Returns wildcard list of all supported types
alias -l gettypes return $startype($winamp(PluginManager,alltypes))

;Retrives info from config file
alias -l get-cfg return $readini -n $cfg-file mIRCAmp $1
alias -l set-cfg {
  if ( $1 == $null ) return
  if ( $2- == $null ) remini $cfg-file mIRCAmp $1
  else writeini $cfg-file mIRCAmp $1 $2-
}

;Formats time in mm:ss style
alias -l mtime {
  if ( $1 < 0 ) return ?:??
  var %secs = $int($calc($1 /1000))
  var %hr = $int($calc(%secs / 3600))
  var %min = $int($calc((%secs % 3600) / 60))
  var %sec = $calc(%secs % 60)
  return $iif(%hr > 0, [ [ %hr ] $+ : ] ) $+ $iif((%min < 10) && (%hr > 0),0) $+ %min $+ : $+ $iif(%sec < 10,0) $+ %sec
}

;Lastdir
alias -l ldir {
  if ( %dz.mamp.lastdir == $null ) set %dz.mamp.lastdir $get-cfg(lastdir)
  if ( %dz.mamp.lastdir == $null ) set %dz.mamp.lastdir $mircdir
  return %dz.mamp.lastdir
}
;Set lastdir
alias -l set-ldir {
  set %dz.mamp.lastdir $nofile($1-)
  set-cfg lastdir %dz.mamp.lastdir
}

;Auto list-save
alias -l psave {
  if ( %dz.mamp.listsave == $null ) set %dz.mamp.listsave $get-cfg(listsave)
  return %dz.mamp.listsave
}
alias -l set-psave {
  set %dz.mamp.listsave $1-
  set-cfg listsave %dz.mamp.listsave
}
alias -l cfg-file return " $+ $scriptdir $+ mIRCamp.cfg $+ "
alias -l udll return $scriptdir $+ amp_in.dll

;Like $dir, but opens existing files only
alias -l openfile {
  var %msg = $1
  var %existfile
  var %exts = $nopath($2)
  var %ldir = $nofile($2)

  set %existfile $dir=" [ $+ [ %msg ] $+ ] " $2
  while ( $isfile(%existfile) == $false ) {
    if ( %existfile == $null ) return
    set %ldir $nofile(%existfile)
    set %existfile $dir=" [ $+ [ %msg ] $+ ] " [ [ %ldir ] $+ [ %exts ] ]
  }
  return %existfile
}

;Like $dir, but for saving files
alias savefile {
  var %msg = $1
  var %sfile
  var %exts = $nopath($2)
  var %ldir = $nofile($2)

  set %sfile $dir=" [ $+ [ %msg ] $+ ] " $2
  while ( $isfile(%sfile) == $true ) {
    var %owrite = $?!="Overwrite the file ' [ $+ [ %sfile ] $+ ] '?"
    if ( %owrite == $true ) break
    set %ldir $nofile(%sfile)
    set %sfile $dir=" [ $+ [ %msg ] $+ ] " [ [ %ldir ] $+ [ %exts ] ]
  }
  return %sfile
}

;The do-nothing alias
alias -l ign return
